#include "HD_UART.h"

void USART2_IRQHandler(void) __attribute__((interrupt()));
void USART3_IRQHandler(void) __attribute__((interrupt()));
#ifdef uart4_enable
// void UART4_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void UART4_IRQHandler(void) __attribute__((interrupt()));
#endif
void UART5_IRQHandler(void) __attribute__((interrupt()));
void UART6_IRQHandler(void) __attribute__((interrupt()));
void UART7_IRQHandler(void) __attribute__((interrupt()));
void UART8_IRQHandler(void) __attribute__((interrupt()));

#define write Bit_SET
#define read Bit_RESET

/*
 * @brief   ʼUART6ӦJ1_485,ĬΪ
 * @param   baud    
 * @retval
 *
 */
void J1_485_Init(uint32_t baud)
{
    /* ʼDE */
    GPIO_InitTypeDef   GPIO_InitStructure;
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOE, ENABLE);
    GPIO_InitStructure.GPIO_Pin = J1_DE_PIN;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
    GPIO_Init(J1_DE_PROT, &GPIO_InitStructure);
    readJ1_485;

    USART_InitTypeDef  USART_InitStructure;
    NVIC_InitTypeDef   NVIC_InitStructure;

    /* UART6  TX --> PC0   RX --> PC1  */
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE);
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_UART6, ENABLE);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;              //PC0Ϊ
    GPIO_Init(GPIOC, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;        //PC1Ϊ
    GPIO_Init(GPIOC, &GPIO_InitStructure);

    USART_InitStructure.USART_BaudRate = baud;
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    USART_InitStructure.USART_Parity = USART_Parity_No;
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
    USART_InitStructure.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;
    USART_Init(UART6, &USART_InitStructure);

    NVIC_InitStructure.NVIC_IRQChannel = UART6_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=3;      //ռȼΪ3
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 3;           //ȼΪ3
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;              //IRQͨʹ
    NVIC_Init(&NVIC_InitStructure);                              //жȼʼ

    USART_ITConfig(UART6, USART_IT_RXNE, ENABLE);

    USART_Cmd(UART6,ENABLE);
}


/*
 * @brief   ʼUART7ӦJ2_485,ĬΪգԴر״̬
 * @param   baud    
 * @retval
 *
 */
void J2_485_Init(uint32_t baud)
{
    /* ʼDE */
    GPIO_InitTypeDef   GPIO_InitStructure;    
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOE, ENABLE);
    GPIO_InitStructure.GPIO_Pin = J2_DE_PIN;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
    GPIO_Init(J2_DE_PROT, &GPIO_InitStructure);
    readJ2_485;

    USART_InitTypeDef  USART_InitStructure;
    NVIC_InitTypeDef   NVIC_InitStructure;

    /* UART7  TX --> PC2   RX --> PC3  */
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE);
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_UART7, ENABLE);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;              //PC2Ϊ
    GPIO_Init(GPIOC, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;        //PC3Ϊ
    GPIO_Init(GPIOC, &GPIO_InitStructure);

    USART_InitStructure.USART_BaudRate = baud;
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    USART_InitStructure.USART_Parity = USART_Parity_No;
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
    USART_InitStructure.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;
    USART_Init(UART7, &USART_InitStructure);

    NVIC_InitStructure.NVIC_IRQChannel = UART7_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=3;      //ռȼΪ3
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 3;           //ȼΪ3
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;              //IRQͨʹ
    NVIC_Init(&NVIC_InitStructure);                              //жȼʼ

    USART_ITConfig(UART7, USART_IT_RXNE, ENABLE);

    USART_Cmd(UART7,ENABLE);
}

/*
 * @brief   ʼUSART2ӦJ3_485,ĬΪգԴر״̬
 * @param   baud    
 * @retval
 *
 */
void J3_485_Init(uint32_t baud)
{
    /* ʼDE */
    GPIO_InitTypeDef   GPIO_InitStructure;    
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);
    GPIO_InitStructure.GPIO_Pin = J3_DE_PIN;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
    GPIO_Init(J3_DE_PROT, &GPIO_InitStructure);
    readJ3_485;
    
    USART_InitTypeDef  USART_InitStructure;
    NVIC_InitTypeDef   NVIC_InitStructure;

    /* USART2  TX --> PA2   RX --> PA3  */
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2, ENABLE);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;              //PA2Ϊ
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;        //PA3Ϊ
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    USART_InitStructure.USART_BaudRate = baud;
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    USART_InitStructure.USART_Parity = USART_Parity_No;
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
    USART_InitStructure.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;
    USART_Init(USART2, &USART_InitStructure);

    NVIC_InitStructure.NVIC_IRQChannel = USART2_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=3;      //ռȼΪ1
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 3;           //ȼΪ1
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;              //IRQͨʹ
    NVIC_Init(&NVIC_InitStructure);                              //жȼʼ

    USART_ITConfig(USART2, USART_IT_RXNE, ENABLE);

    USART_Cmd(USART2,ENABLE);
}

/*
 * @brief   ʼUART8ӦJ4_485,ĬΪգԴر״̬
 * @param   baud    
 * @retval
 *
 */
void J4_485_Init(uint32_t baud)
{
    /* ʼDE */
    GPIO_InitTypeDef   GPIO_InitStructure;    
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);
    GPIO_InitStructure.GPIO_Pin = J4_DE_PIN;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
    GPIO_Init(J4_DE_PROT, &GPIO_InitStructure);
    readJ4_485;

    USART_InitTypeDef  USART_InitStructure;
    NVIC_InitTypeDef   NVIC_InitStructure;

    /* UART8  TX --> PC4   RX --> PC5  */
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE);
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_UART8, ENABLE);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;              //PC4Ϊ
    GPIO_Init(GPIOC, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;        //PC5Ϊ
    GPIO_Init(GPIOC, &GPIO_InitStructure);

    USART_InitStructure.USART_BaudRate = baud;
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    USART_InitStructure.USART_Parity = USART_Parity_No;
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
    USART_InitStructure.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;
    USART_Init(UART8, &USART_InitStructure);

    NVIC_InitStructure.NVIC_IRQChannel = UART8_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=3;      //ռȼΪ3
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 3;           //ȼΪ3
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;              //IRQͨʹ
    NVIC_Init(&NVIC_InitStructure);                              //жȼʼ

    USART_ITConfig(UART8, USART_IT_RXNE, ENABLE);

    USART_Cmd(UART8,ENABLE);
}

/*
 * @brief   ʼUSART3ڿJ5-06485ӿ,ÿƵ485ΪJ0Դȫر
 * @param   baud    
 * @retval
 *
 */
void J5_0_485_Init(uint32_t baud)
{
    /* ʼDE */
    GPIO_InitTypeDef   GPIO_InitStructure;
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOD,ENABLE);
    GPIO_InitStructure.GPIO_Pin = J5_0_DE_PIN;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
    readJ5_0_485;
    GPIO_InitStructure.GPIO_Pin = J5_0_A_PIN;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
    GPIO_InitStructure.GPIO_Pin = J5_0_B_PIN;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
    GPIO_InitStructure.GPIO_Pin = J5_0_C_PIN;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
    USART_CONNET_J0();

    USART_InitTypeDef  USART_InitStructure;
    NVIC_InitTypeDef   NVIC_InitStructure;

    /* USART3  TX --> PB10   RX --> PB11  */
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART3, ENABLE);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;              //PB10Ϊ
    GPIO_Init(GPIOB, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;        //PB11Ϊ
    GPIO_Init(GPIOB, &GPIO_InitStructure);

    USART_InitStructure.USART_BaudRate = baud;
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    USART_InitStructure.USART_Parity = USART_Parity_No;
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
    USART_InitStructure.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;
    USART_Init(USART3, &USART_InitStructure);

    NVIC_InitStructure.NVIC_IRQChannel = USART3_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=1;      //ռȼΪ1
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;           //ȼΪ1
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;              //IRQͨʹ
    NVIC_Init(&NVIC_InitStructure);                              //жȼʼ

    USART_ITConfig(USART3, USART_IT_RXNE, ENABLE);
//    USART_ITConfig(USART3, USART_IT_IDLE, ENABLE);

    USART_Cmd(USART3,ENABLE);
}
/*
 * Function Name  : USART_CONNET_J0
 * Description    : ƴ3J0Ӧ485.
 * Input          : None
 * Return         : None
 **/
void USART_CONNET_J0(void)
{
    GPIO_WriteBit(J5_0_A_PROT, J5_0_A_PIN, Bit_RESET);
    GPIO_WriteBit(J5_0_B_PROT, J5_0_B_PIN, Bit_RESET);
    GPIO_WriteBit(J5_0_C_PROT, J5_0_C_PIN, Bit_RESET);
}

/*
 * Function Name  : USART_CONNET_J5
 * Description    : ƴ3J5Ӧ485.
 * Input          : None
 * Return         : None
 **/
void USART_CONNET_J5(void)
{
    GPIO_WriteBit(J5_0_A_PROT, J5_0_A_PIN, Bit_RESET);
    GPIO_WriteBit(J5_0_B_PROT, J5_0_B_PIN, Bit_RESET);
    GPIO_WriteBit(J5_0_C_PROT, J5_0_C_PIN, Bit_SET);
}

/*
 * Function Name  : USART_CONNET_J6
 * Description    : ƴ3J6Ӧ485.
 * Input          : None
 * Return         : None
 **/
void USART_CONNET_J6(void)
{
    GPIO_WriteBit(J5_0_A_PROT, J5_0_A_PIN, Bit_RESET);
    GPIO_WriteBit(J5_0_B_PROT, J5_0_B_PIN, Bit_SET);
    GPIO_WriteBit(J5_0_C_PROT, J5_0_C_PIN, Bit_RESET);
}

/*
 * Function Name  : USART_CONNET_J7
 * Description    : ƴ3J7Ӧ485.
 * Input          : None
 * Return         : None
 **/
void USART_CONNET_J7(void)
{
    GPIO_WriteBit(J5_0_A_PROT, J5_0_A_PIN, Bit_RESET);
    GPIO_WriteBit(J5_0_B_PROT, J5_0_B_PIN, Bit_SET);
    GPIO_WriteBit(J5_0_C_PROT, J5_0_C_PIN, Bit_SET);
}

/*
 * Function Name  : USART_CONNET_J8
 * Description    : ƴ3J8Ӧ485.
 * Input          : None
 * Return         : None
 **/
void USART_CONNET_J8(void)
{
    GPIO_WriteBit(J5_0_A_PROT, J5_0_A_PIN, Bit_SET);
    GPIO_WriteBit(J5_0_B_PROT, J5_0_B_PIN, Bit_RESET);
    GPIO_WriteBit(J5_0_C_PROT, J5_0_C_PIN, Bit_RESET);
}

/*
 * Function Name  : USART_CONNET_J9
 * Description    : ƴ3J9Ӧ485.
 * Input          : None
 * Return         : None
 **/
void USART_CONNET_J9(void)
{
    GPIO_WriteBit(J5_0_A_PROT, J5_0_A_PIN, Bit_SET);
    GPIO_WriteBit(J5_0_B_PROT, J5_0_B_PIN, Bit_RESET);
    GPIO_WriteBit(J5_0_C_PROT, J5_0_C_PIN, Bit_SET);
}


#ifdef uart4_enable
/*
 * @brief   ʼUART4ӦLORA
 * @param   baud    
 * @retval
 *
 */
void LORA_UART4_Init(uint32_t baud)
{
    GPIO_InitTypeDef   GPIO_InitStructure;
    USART_InitTypeDef  USART_InitStructure;
    NVIC_InitTypeDef   NVIC_InitStructure;

    /* UART4  TX --> PC10   RX --> PC11  */
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE);
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_UART4, ENABLE);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;              //PC10Ϊ
    GPIO_Init(GPIOC, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;        //PC11Ϊ
    GPIO_Init(GPIOC, &GPIO_InitStructure);

    USART_InitStructure.USART_BaudRate = baud;
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    USART_InitStructure.USART_Parity = USART_Parity_No;
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
    USART_InitStructure.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;
    USART_Init(UART4, &USART_InitStructure);

    NVIC_InitStructure.NVIC_IRQChannel = UART4_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=3;      //ռȼΪ3
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 3;           //ȼΪ3
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;              //IRQͨʹ
    NVIC_Init(&NVIC_InitStructure);                              //жȼʼ

    USART_ITConfig(UART4, USART_IT_RXNE, ENABLE);

    USART_Cmd(UART4,ENABLE);
}
#endif

/*
 * @brief   ʼUART5ӦĶϴ
 * @param   baud    
 * @retval
 *
 */
void Upward_UART5_Init(uint32_t baud)
{
    GPIO_InitTypeDef   GPIO_InitStructure;
    USART_InitTypeDef  USART_InitStructure;
    NVIC_InitTypeDef   NVIC_InitStructure;

    /* UART5  TX --> PC12   RX --> PD2  */
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE);
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOD, ENABLE);
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_UART5, ENABLE);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;              //PC12Ϊ
    GPIO_Init(GPIOC, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;        //PD2Ϊ
    GPIO_Init(GPIOD, &GPIO_InitStructure);

    USART_InitStructure.USART_BaudRate = baud;
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    USART_InitStructure.USART_Parity = USART_Parity_No;
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
    USART_InitStructure.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;
    USART_Init(UART5, &USART_InitStructure);

    USART_ITConfig(UART5, USART_IT_RXNE, ENABLE);

    NVIC_InitStructure.NVIC_IRQChannel = UART5_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=1;      //ռȼΪ3
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 3;           //ȼΪ3
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;              //IRQͨʹ
    NVIC_Init(&NVIC_InitStructure);                              //жȼʼ

    USART_Cmd(UART5,ENABLE);
}



void USART2_IRQHandler(void)
{
    J3_Interrupt();
}

void USART3_IRQHandler(void)
{
    J5_0_Interrupt();
}

#ifdef uart4_enable
void UART4_IRQHandler(void)
{

}
#endif

void UART5_IRQHandler(void)
{
    Upward_Interrupt();
}

void UART6_IRQHandler(void)
{
    J1_Interrupt();
}

void UART7_IRQHandler(void)
{
    J2_Interrupt();
}

void UART8_IRQHandler(void)
{
    J4_Interrupt();
}


/*
 * @brief   һַ
 * @param   pUSARTx 
            data    ַ
 * @retval
 *
 */
void USARTx_SendByte(USART_TypeDef* pUSARTx, uint8_t data)
{   
    while(USART_GetFlagStatus(pUSARTx, USART_FLAG_TXE) == RESET) /* waiting for sending finish */
    {
    }
    USART_SendData(pUSARTx, data);
}

/*
 * @brief   ַ
 * @param   pUSARTx 
            data    ַ
            len     ַĳ
 * @retval
 *
 */
void USARTx_SendStr_Len(USART_TypeDef* pUSARTx, char *str, int len)
{
    if (pUSARTx == J1_USART) {
        writeJ1_485;
    } else if (pUSARTx == J2_USART) {
        writeJ2_485;    
    } else if (pUSARTx == J3_USART) {
        writeJ3_485;    
    } else if (pUSARTx == J4_USART) {
        writeJ4_485;    
    } else if (pUSARTx == J5_0_USART) {
        writeJ5_0_485;    
    }

    for (int i = 0; i < len; i++) {
        USARTx_SendByte(pUSARTx, str[i]);
    }
    
    if (pUSARTx == J1_USART) {
        readJ1_485;
    } else if (pUSARTx == J2_USART) {
        readJ2_485;    
    } else if (pUSARTx == J3_USART) {
        readJ3_485;    
    } else if (pUSARTx == J4_USART) {
        readJ4_485;    
    } else if (pUSARTx == J5_0_USART) {
        readJ5_0_485;
    }
}















